/* imontty
   Show status of ISDN lines of isdn4linux

   (c) 1995 Volker Goetz
*/

#include "isdn.h"
#include <iostream.h>
#include <fstream.h>
#include <String.h>

int main()
{

   // The contents of the info device, currently 5 lines
   String Info[5];
 
   // open the info device and check if ok

   String infodevice="/dev/isdninfo";

   ifstream isdninfo(infodevice);
   if (!isdninfo)
   {
      cerr << "ERROR: cannot open ISDN info device " << infodevice << endl;
      return 1;
   }
   isdninfo.unsetf(ios::skipws);      // don't skip white space

   // read 5 lines and get all the necessary info
   for (int i = 0; i < 5; i++)
      readline(isdninfo, Info[i]);

   String chmap[ISDN_MAX_CHANNELS];
   String drmap[ISDN_MAX_CHANNELS];
   String usage[ISDN_MAX_CHANNELS];
   String flags[ISDN_MAX_CHANNELS];
   String phone[ISDN_MAX_CHANNELS];
   
   // and close the input stream
   isdninfo.close();
   
   // Now do some conversions...

   String separator=" ";
   int count;

   // split output of isdninfo into entries of an array

   count = split(Info[0].after(6), chmap, ISDN_MAX_CHANNELS, separator);
   count = split(Info[1].after(6), drmap, ISDN_MAX_CHANNELS, separator);
   count = split(Info[2].after(6), usage, ISDN_MAX_CHANNELS, separator);
   count = split(Info[3].after(6), flags, ISDN_MAX_CHANNELS, separator);
   count = split(Info[4].after(6), phone, ISDN_MAX_CHANNELS, separator);

   int i_chmap[ISDN_MAX_CHANNELS];
   int i_drmap[ISDN_MAX_CHANNELS];
   int i_usage[ISDN_MAX_CHANNELS];
   int i_flags[ISDN_MAX_CHANNELS];
   int i_phone[ISDN_MAX_CHANNELS];

   
   // convert some of the entries from string to integer

   for (i = 0; i < count; i++)
      i_chmap[i] = atoi( (const char*)chmap[i] );
   
   for (i = 0; i < count; i++)
      i_drmap[i] = atoi( (const char*)drmap[i]);
   
   for (i = 0; i < count; i++)
      i_usage[i] = atoi( (const char*)usage[i]);
   

   // print out actual status of all available channels

   int usage_akt;
  
   // clear screen
   // quite bad since "hard coded" escape sequence

   // cout << "\033[1;1H\033[J";

   cout << endl << "ISDN channel status:" << endl << endl;
   cout << "Channel #   Dr/Ch   Direction\tUsage\t\tNumber" << endl;
   cout << "-----------------------------------------------------------------------" << endl;
   
   for (i = 0; i < count; i++)
   {
      // check whether channel is available
      if ( (i_chmap[i] >= 0) && (i_drmap[i] >= 0))
      {
	 cout << "Channel " << i << ":  " << i_drmap[i] << "/" << i_chmap[i] << "     " ;
	 usage_akt = i_usage[i];
	 
	 if (usage_akt > 128)
	 {
	    cout << "outgoing\t";
	    usage_akt = usage_akt - 128;
	 }
	 else
	 {
	    if (usage_akt > 0)
	       cout << "incoming\t";
	    else
	       cout << "free\t";
	 }
	 
	 switch (usage_akt)
	 {
	    case 5: cout << "fax\t\t"; break;
	    case 4: cout << "voice\t\t"; break;
	    case 3: cout << "IP interface\t"; break;
	    case 2: cout << "tty emulation\t"; break;
	    case 1: cout << "raw device\t"; break;
	    case 0: cout << "--\t\t"; break;
	    default: cout << "unknown\t"; break;
	 }
	 
	 cout << phone[i] << endl;
      } // if
   } // for i
   cout << endl;


   return 0;
}






